/*
 * TCP ECHO饤
 */


#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "tcplib.h"


static int err_quit(const char *mes)
{
	printf("%s\n",mes);
	return 0;
}


static void str_cli(FILE *fp,int sockfd)
{
	char sendline[MAXLINE],recvline[MAXLINE];


	while(fgets(sendline,MAXLINE,fp)!=NULL)
	{
		if(writen(sockfd,sendline,strlen(sendline))<0)return;
		if(readline(sockfd,recvline,MAXLINE)==0)
			err_quit("str_cli: server terminated prematurely");
		fputs(recvline,stdout);
	}
}


int main(int argc, char *argv[])
{
	int sockfd;
	struct hostent *hostent;
	struct sockaddr_in servaddr;


	if(argc!=2)return err_quit("usage : tcpcli <IPaddress>");

	/* åȤκ */
	if((sockfd=socket(AF_INET, SOCK_STREAM, 0))< 0)
		return _perror("Failed socket()");

	/* ФIPɥ쥹 */
	hostent = gethostbyname(argv[1]);
	if (hostent == NULL)
	{
		_perror("cl:gethostbyname");
		exit(1);
	}
	bzero(&servaddr, sizeof(servaddr));
	servaddr.sin_family = AF_INET;
	servaddr.sin_port = htons(SERV_PORT);
	memcpy((char *)&servaddr.sin_addr, (char *)hostent->h_addr,hostent->h_length);

	if(connect(sockfd,(struct sockaddr*)&servaddr, sizeof(servaddr))<0)
		return _perror("Failed connect()");

	str_cli(stdin,sockfd);

	return 0;
}
